
Figure - Bug #117377
测试 Test-ST # 113421 (New): V4.0功能与专项测试

测试 Test-ST # 113422 (New): V4.0专项--AF专项--monkey测试

【AF】【EVT3】【Monkey】Monkey测试48小时，出现CRASH: com.android.settings（19）
2023-04-11 10:35 - CD TEST-方永红

Status: CLOSED Start date: 2023-04-11

Priority: Urgent Due date:

Assignee: CD TEST-方永红 % Done: 100%

Category: CD-FW Estimated time: 0.00 hour

Target version:

Need_Info: -- Found Version: FlatBuild_HH_MCE_FSE.M.D.user.01.00.C103(X103).202304070441

Resolution: FIXED Degrated: No

Severity: Critical Verified Version: FlatBuild_HH_MCE_FSE.M.D.user.01.00.C103(X103).202304140602

Reproducibility: Occasionally Fixed Version: 2023-04-11

Test Type: ST Root cause: 在 onSaveState 后执行 Fragment Pop 操作导致。

Description

【执行命令】

adb shell

monkey --pkg-blacklist-file /sdcard/blacklist.txt --ignore-crashes --ignore-timeouts --ignore-security-exceptions --monitor-native-crashes

--ignore-native-crashes -s 20 --throttle 500 --pct-touch 30 --pct-motion 15 --pct-nav 15 --pct-majornav 15 --pct-syskeys 5 --pct-appswitch 10

--pct-anyevent 10 --ignore-crashes -v -v -v 345600 2>/sdcard/error.txt 1>/sdcard/info.txt

【错误信息】

CRASH: com.android.settings (pid 25412)

// Short Msg: java.lang.IllegalStateException

// Long Msg: java.lang.IllegalStateException: Can not perform this action after onSaveInstanceState

// Build Label: TC/figure_CN/figure:12/SKQ1.220201.001/2768:user/test-keys

// Build Changelist: 2768

// Build Time: 1680817342000

// java.lang.IllegalStateException: Can not perform this action after onSaveInstanceState

//     at androidx.fragment.app.FragmentManager.checkStateLoss(FragmentManager.java:1864)

//     at androidx.fragment.app.FragmentManager.ensureExecReady(FragmentManager.java:1967)

//     at androidx.fragment.app.FragmentManager.execPendingActions(FragmentManager.java:2016)

//     at androidx.fragment.app.FragmentManager.popBackStackImmediate(FragmentManager.java:784)

//     at androidx.fragment.app.FragmentManager.popBackStackImmediate(FragmentManager.java:739)

//     at

com.android.settings.homepage.SettingsHomepageActivity.lambda$changeSettingsDetailsFragment$3(SettingsHomepageActivity.java:440)

//     at com.android.settings.homepage.SettingsHomepageActivity.$r8$lambda$GDM2RdS1ITQZQUFBqNf1SBHxq9k(Unknown Source:0)

//     at com.android.settings.homepage.SettingsHomepageActivity$$ExternalSyntheticLambda3.run(Unknown Source:10)

//     at android.os.Handler.handleCallback(Handler.java:938)

//     at android.os.Handler.dispatchMessage(Handler.java:99)

//     at android.os.Looper.loopOnce(Looper.java:201)

//     at android.os.Looper.loop(Looper.java:288)

//     at android.app.ActivityThread.main(ActivityThread.java:7880)

//     at java.lang.reflect.Method.invoke(Native Method)

//     at com.android.internal.os.RuntimeInit$MethodAndArgsCaller.run(RuntimeInit.java:548)

//     at com.android.internal.os.ZygoteInit.main(ZygoteInit.java:1009)

// 
History

#1 - 2023-04-11 11:07 - CD TEST-方永红

- Reproducibility changed from Every time to Occasionally

#2 - 2023-04-11 16:16 - IoT scm

Gerrit Merge Information：

ID Project Branch Uploader

192938 general/platform/packages/apps/Settin

gs

Pre_figure_turbox-c2130c-la1.1-qssi12

-dev

tao.liao@thundersoft.com

AF:Settings: Fix monkey crash problem.TC-RID: 1201-0201813IssueID: TS-R-BUG-117377Change-Id: I4992e9df42fef8ad6cb8042cc1a7d9575ee43e58

#3 - 2023-04-11 17:02 - CD FW-廖涛

- Status changed from New to RESOLVED

- Assignee changed from CD FW-廖涛 to CD TEST-方永红

- % Done changed from 0 to 100

- Resolution changed from -- to FIXED

- Degrated changed from -- to No

- Fixed Version set to 2023-04-11

- Root cause set to 在 onSaveState 后执行 Fragment Pop 操作导致。

■ Current conclusion

已处理，代码已入库。

■ My analysis

小概率问题，延迟操作恰好进入开始执行，然后 onSaveState 执行了，再去执行 Fragment 的 Pop 操作导致异常。

修复方案：

在执行 Fragment 的 Pop 操作前，增加 saveState 状态判断。

■ Next action

测试验证。

#4 - 2023-04-13 10:14 - CD TEST-方永红

4.13

12号的DB未复现，继续跟踪两个版本

#5 - 2023-04-14 09:52 - CD TEST-方永红

4.14

0091版本未复现，继续跟踪一个版本
#6 - 2023-04-15 10:48 - CD TEST-方永红

- Status changed from RESOLVED to VERIFIED

- Verified Version set to FlatBuild_HH_MCE_FSE.M.D.user.01.00.C103(X103).202304140602

4.15

14号DB未复现

先关闭

#7 - 2023-04-15 10:49 - CD TEST-方永红

- Status changed from VERIFIED to CLOSED

Files

error.txt 465 KB 2023-04-11 CD TEST-方永红

tlog_sts40x190078_000044_0410215449.tar.gz 19.5 MB 2023-04-11 CD TEST-方永红
